function [ lap ] = laplacian( z, hx )
% This function calculates the laplacian of a given variable Z stored as a
% matrix z(i,j)and where z(i,j) represents value of Z at (i,j)th point on
% the spatial grid. The boundary conditions are periodic.

n = size(z, 2);

lap = zeros(n,n);

for i = 1:n
    for j = 1:n
        lap(i,j) = 0;
        if j~= n
            lap(i,j) = lap(i,j) + z(i,j+1) - z(i,j);
            if j~= 1
                lap(i,j) = lap(i,j) + z(i,j-1) - z(i,j);
                if i~= 1
                    lap(i,j) = lap(i,j) + z(i-1,j) - z(i,j);
                    if i~=n
                        lap(i,j) = lap(i,j) + z(i+1,j) - z(i,j);
                        if j== n
                            lap(i,j) = lap(i,j) + z(i,1) - z(i,j);
                            if j== 1
                                lap(i,j) = lap(i,j) + z(i,n) - z(i,j);
                                if i== n
                                    lap(i,j) = lap(i,j) + z(1,j) - z(i,j);
                                    if i== 1
                                        lap(i,j) = lap(i,j) + z(n,j) - z(i,j);
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
        lap(i,j) = lap(i,j)/hx/hx;
    end
end

                        
                        
            
        
        



end

