% Reaction Diffusion Equations:Brusselator Equations
 
% Initialization

a = 1;     % parameter a
b = 3.4;     % parameter b
Du = 0.002;    
Dv = 0.002;
hx = 0.01;    % spatial grid cell length
ht = 0.005;    % time step
t_max = 0; 
x_max = 1;
x = 0:hx:x_max;
y = x;
n = size(x, 2);  % number of time iterations
nt = t_max/ht; % number of space points along one direction
u = zeros(n,n); % initialization of quantity u and v
v = u;
p = u;          % Initialization of intermediate quantities p and q
q = v;               % corresponding to u and v respectively
delta = 0.3;

r = ht/hx/hx;

for i =1:n
    for j =1:n
        %u(i,j) = a + delta*rand(1);
        %v(i,j) = b/a + delta*rand(1);
        u(i,j) = 0.5 + y;
        v(i,j) = 1 + 5*x;
    end
end
m1 = u;
m2 = v;


% Main Loop

for t = 1:nt
    p = u;
    q = v;
    
    u = ht*(Du*laplacian(p, hx) + brusselator_f(p, q, a, b)) + p;   % Main Iteration Loops for u and v
    v = ht*(Dv*laplacian(q, hx) + brusselator_g(p, q, a, b)) + q;   
    
    time_elapsed = t*ht;  % time progress to be displayed on the screen as the program runs
    t_max
    nt
    t
end

% Display of results

mesh(x,y,v) % creates a mesh plot of the results



            
            
            
            
            
            